/*
 Controller class declaration - this is abstract class, some methods are
 pure virtual
*/

#ifndef CONTROLLER_H
#define CONTROLLER_H

//necessary includes for class members and functions 
#include <string>

//controller type enumerator
typedef enum ContrType
{
	eUndef,
  eE1contr,
	eE3contr,
	eSONETcontr,
	eSerialIf,
	eSerialSubif,
	eSonetContr,
  eATMIf,
  eATMSubif,
  ePOSif,
  ePOSSubif
} ContrType;

class Controller
{
 protected:
  ContrType mType;
  std::string mDescr;
  std::string mName;

 public:
  //constructor
  //default type is undefined 
  Controller(): mType(eUndef),mDescr(""),mName("") {};
  //destructor, always virtual for base class, good practice
  virtual ~Controller(){};
  //pure virtual method
  virtual void parsContrSection(std::string& rline)=0;
  ContrType getType() const {return mType;}
  std::string getDescr() const {return mDescr;}
  void setDescr(std::string descr) {mDescr = descr;}
  void setName(std::string name) {mName=name;}
  std::string getName() const {return mName;}
  static std::string getCID(std::string str);
  static std::string getBID(std::string str);
  static bool checirctype(std::string str);
};

#endif
