/*
 Controller class declaration
*/

#ifndef E1CONTROLLER_H
#define E1CONTROLLER_H

//necessary declaration for class members and methods
#include <string>
#include <vector>

#include "Controller.h"
#include "Changrp.h"

class GIface;

class E1Controller: public Controller
{
 private:
  std::vector<Changrp> mChangrpV;
  std::string mframing;
  std::string mclockSrc;
  bool mUnframed;

 public:
  /** number of timeslots in E1 */
  static const unsigned int mcTimeslots=32;

  //constructor
  E1Controller();
  //destructor
  ~E1Controller();
  int ChangrCnt();
  bool isUnframed() const;
  std::string getFraming() const {return mframing;}
  void setFraming(std::string str);
  std::string getClockSrc() const {return mclockSrc;}
  void setClockSrc(std::string str);
  void setUnframed(bool val) {mUnframed=val;}
  /**
   * inspect method (const), return reference to const vector of channel groups
   */     
  const std::vector<Changrp>& getAllChangr() const { return mChangrpV; }
  Changrp& addChangr(int id,std::string range);
  void makeChangrpSerlinks(std::vector<GIface>& rSerIfacesV);
  void parsContrSection(std::string& rline);
  std::string getContrID();
  void printDebuginfo() const;
};

#endif
