/**
 * @file
 * @brief E3 controller class definition
 * @author Miroslav Kubelik
 * @date 2007
 */

#ifndef E3CONTROLLER_H
#define E3CONTROLLER_H

//headers with necessary definitions for currect class declaration
#include <string>
#include <vector>
#include "Controller.h"

//forward declaration
class GIface;
class E1Controller;

/**
 * class for the E3 controller
 */
class E3Controller: public Controller
{
 private:
  static const int mcNumSubE1=16;
  /**
   * sub e1 controllers array pointer, we need copy constructor
   * WARNING: if subE1 is not present in configuration, has empty id getName return
   * empty string   
   */     
  E1Controller* mpE1ControllerA; 

 public:
  //constructor
  E3Controller();
  //copy constructor, nedded if ve can push_back this class with pointer to vector
  E3Controller(const E3Controller& m);
  //destructor
  ~E3Controller();
  void parsContrSection(std::string& rline);
  void printDebuginfo();
  /** inspect function - return const pointer to array of subE1 */
  const E1Controller* getAllSubE1() const { return mpE1ControllerA; }
  static int getSubE1Count() {return mcNumSubE1;}
  std::string getSubE1Name(unsigned int subE1id) const;
  void makeChangrpSerlinks(std::vector<GIface>& rSerIfacesV);
};

#endif
