/*
 Sonet Controller class declaration
*/

#ifndef SONETCONTROLLER_H
#define SONETCONTROLLER_H

//needed headers
#include <vector>
#include <string>
#include "Controller.h"
 
//forward declaration
class E1Controller;
class GIface;

class SonetController: public Controller
{
 private:
  unsigned int mAu4,mTug3;
  static const int mcNumSubE1=63;
  /**
   * sub e1 controllers array pointer, we need copy constructor
   * WARNING: if subE1 is not present in configuration, has empty id getName return
   * empty string       
   */     
  E1Controller* mpE1ControllerA;
   
 public:
  //constructor
  SonetController();
  //copy constructor, nedded if ve can push_back this class with pointer to vector
  SonetController(const SonetController& m);
  //destructor
  ~SonetController();
  void parsContrSection(std::string& rline);
  /**
   * inspect function - return const pointer to array of subE1
   */
  const E1Controller* getAllSubE1() const { return mpE1ControllerA; }
  static int getSubE1Count() {return mcNumSubE1;}
  static unsigned int getE1numId(unsigned int tug3, unsigned int tug2, unsigned int e1);
  static std::string getE1strId(std::string SonetContrID,unsigned int au4,unsigned int tug3,unsigned int tug2, unsigned int e1);
  void makeChangrpSerlinks(std::vector<GIface>& rSerIfacesV);
  std::string getSubE1Name(unsigned int subE1id) const;
  void printDebuginfo();
};

#endif
