## A configure script for device manager php application
## This application is based of Zend Framework

AC_INIT(app/controllers/IndexController.php)
AC_CONFIG_AUX_DIR(config)

dnl default prefix is some directory in our www-apps like dirs
AC_PREFIX_DEFAULT(/usr/home/www/devices)
AM_INIT_AUTOMAKE(devices,4.4)

AC_ARG_WITH(php,[  --with-php[=PATH]               Look for PHP executable needed for CLI scripts],
[
  if test $withval != "yes"; then
    AC_MSG_CHECKING([for php])
    if test -x $withval; then
      PHP=$withval
      AC_MSG_RESULT($PHP)
    else
      PHP=no
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([$withval: not an executable file])
    fi
  else
    AC_PATH_PROG(PHP,"php",no)
  fi
],[
 AC_PATH_PROG(PHP,"php",no)
]
)
if test $PHP = "no"; then
  AC_MSG_ERROR([no PHP binary found])
fi

dnl Check for PHP version > 5.2.0
AC_MSG_CHECKING([for php version 5.2.0+])
PHPVERCOMPARE=`$PHP -r "echo version_compare(PHP_VERSION,'5.2.0');"`
if test $PHPVERCOMPARE = "-1"; then
  AC_MSG_ERROR([PHP version is not 5.2.0 or better])
else
 AC_MSG_RESULT([yes])
fi

AC_ARG_WITH(zf-library-dir,[  --with-zf-library-dir[=DIR]      Zend Framework library directory  [default=/usr/home/www/zendframework/library]],
  [ZFLIBDIR="$withval"],
  [ZFLIBDIR="/usr/home/www/zendframework/library"])

AC_ARG_WITH(web-base,[  --with-web-base[=DIR]           Relative URL for the application  [default=devices]],
  [WEBBASE="$withval"],
  [WEBBASE="devices"])


dnl output direcotry is our default prefix directory
OUTPUTDIR=$ac_default_prefix

AC_SUBST(ZFLIBDIR)
AC_SUBST(OUTPUTDIR)
AC_SUBST(WEBBASE)

AC_OUTPUT(www/.htaccess \
Makefile \
www/Makefile \
app/Makefile \
app/EnvConfLoader.php
)
