/**
 * @file
 * @brief the portinfo cisco device exporter class declaration
 * @author Miroslav Kubelik
 * @date 2007
 */

#ifndef PORTINFO_CISCODEV_H
#define PORTINFO_CISCODEV_H

/* necessary declaration for class definition */
#include <string>
#include "xmlParser/xmlParser.h"

/* forward declaration - for pointers and references */
class CiscoBox;
class SyncSummary;
class CiscoBoxSummary;

namespace Portinfo
{
 /** @brief portinfo cisco device class
  */
 class CiscoDev
 {
  public:
   static std::string getXMLexport(const CiscoBox& rCiscoBox);
   static XMLNode getXMLNode(const CiscoBox& rCiscoBox);
   static XMLNode getXMLSummary(const CiscoBox& rCiscoBox);
  private:
   static XMLNode portinfoE1Controllers(const CiscoBox& rCiscoBox);
   static XMLNode portinfoE3Controllers(const CiscoBox& rCiscoBox);
   static XMLNode portinfoSonetControllers(const CiscoBox& rCiscoBox);
 };
};

#endif
