/**
 * @file
 * @brief the portinfo cisco device group summary class implementation
 * @author Miroslav Kubelik
 * @date August 2007
 */

//STDC++ and STL Headers

//C and local headers
#include "CiscoDevGroupSummary.h"

using namespace std;

//---------------------------------------------------------------------------
/**
 * @brief add the summary for one ciscobox to our whole summary
 */
void Portinfo::CiscoDevGroupSummary::addCiscoBoxSummary(const CiscoBoxSummary& rCiscoBoxSum)
{
 //add E1 summary
 mE1Summary.addFromSummary(rCiscoBoxSum.getE1Summary(),true);
 //add E3 summary
 mE3Summary.addFromSummary(rCiscoBoxSum.getE3Summary(),true);
 //add Sonet summary
 mSonetSummary.addFromSummary(rCiscoBoxSum.getSonetSummary(),true);
 //add whole summary
 mWholeSyncSummary.addFromSummary(rCiscoBoxSum.getWholeSyncSummary(),true);
}
