/**
 * @file
 * @brief the portinfo cisco device group summary declaration
 * @author Miroslav Kubelik
 * @date 2007
 */

#ifndef PORTINFO_CISCODEVGROUPSUMMARY_H
#define PORTINFO_CISCODEVGROUPSUMMARY_H

/* necessary declaration for class definition */
#include "xmlParser/xmlParser.h"
#include "CiscoBoxSummary.h"

/* forward declaration - for pointers and references */

namespace Portinfo
{
 /**
 * @brief summary for a portinfo cisco device group
 * It just extends CiscoBoxSummary because we neeed same kind of summaries
 * as for one box. Summaries for every cisco box in a group is just added to
 * the current summaries. Hence this class hasn't summaries for every single box,
 * it has only whole group summary.
 */
 class CiscoDevGroupSummary: public CiscoBoxSummary
 {
  public:
   //constructor, create empty summary
   CiscoDevGroupSummary(): CiscoBoxSummary() {}

   //desctructor
   virtual ~CiscoDevGroupSummary() {}

   /** @brief add one CiscoBoxSummary to our summary*/
   void addCiscoBoxSummary(const CiscoBoxSummary& rCiscoBoxSum);
 };
};

#endif
