/**
 * @file
 * @brief declaration for the portinfo xml export class for the E1 controller
 * @author Miroslav Kubelik
 * @date 2007
 */

#ifndef PORTINFO_CISCOE1CONTR_H
#define PORTINFO_CISCOE1CONTR_H

/* necessary declaration for a class definition */
#include <vector>
#include "xmlParser/xmlParser.h"

/* forward declaration - for pointers and references */
class E1Controller;
class Changrp;

namespace Portinfo
{
 class CiscoE1Contr
 {
  private:
   XMLNode mSpXMLNode;

  public:
   //constructor
   CiscoE1Contr();
   XMLNode getXMLnode(const E1Controller& rE1contr);
   static XMLNode getXMLnodeChannelGroups(const std::vector<Changrp>& rChangrpV);
   virtual ~CiscoE1Contr() {};
 }; 
};

#endif
