/*
  File autogenerated by gengetopt version 2.18
  generated with the following command:
  gengetopt --file-name=portinfoexpopt --no-handle-version --unamed-opts=DEVICES

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "portinfoexpopt.h"

const char *gengetopt_args_info_purpose = "This program exports some parts of the configurations for the network\ndevices to the XML file. The program can export information for a group of\ndevices. The XML file is then printed to the STDOUT.\nExported informations:\n - all E1 lines with all channel groups and the correspoded serial interfaces.\n - all E3 lines with all sub-E1 lines\n - all SONET lines with all sub-E1 lines\n - summaries for each device and a group of devices\n";

const char *gengetopt_args_info_usage = "Usage: portinfoexp [OPTIONS]... [DEVICES]...";

const char *gengetopt_args_info_help[] = {
  "  -h, --help                Print help and exit",
  "  -V, --version             Print version and exit",
  "  -d, --devconfdir=dirpath  the directory with device configurations",
  "  -r, --reportname=STRING   the name for exported XML report",
  "  -c, --xmlconf=filepath    the XML configuration file",
  "  -m, --mediadir=dirpath    the name for the directorty for all exported media \n                              files (images, RRD files)",
    0
};

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->devconfdir_given = 0 ;
  args_info->reportname_given = 0 ;
  args_info->xmlconf_given = 0 ;
  args_info->mediadir_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->devconfdir_arg = NULL;
  args_info->devconfdir_orig = NULL;
  args_info->reportname_arg = NULL;
  args_info->reportname_orig = NULL;
  args_info->xmlconf_arg = NULL;
  args_info->xmlconf_orig = NULL;
  args_info->mediadir_arg = NULL;
  args_info->mediadir_orig = NULL;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{
  args_info->help_help = gengetopt_args_info_help[0] ;
  args_info->version_help = gengetopt_args_info_help[1] ;
  args_info->devconfdir_help = gengetopt_args_info_help[2] ;
  args_info->reportname_help = gengetopt_args_info_help[3] ;
  args_info->xmlconf_help = gengetopt_args_info_help[4] ;
  args_info->mediadir_help = gengetopt_args_info_help[5] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  cmdline_parser_print_version ();

  if (strlen(gengetopt_args_info_purpose) > 0)
    printf("\n%s\n", gengetopt_args_info_purpose);

  printf("\n%s\n\n", gengetopt_args_info_usage);
  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->devconfdir_arg)
    {
      free (args_info->devconfdir_arg); /* free previous argument */
      args_info->devconfdir_arg = 0;
    }
  if (args_info->devconfdir_orig)
    {
      free (args_info->devconfdir_orig); /* free previous argument */
      args_info->devconfdir_orig = 0;
    }
  if (args_info->reportname_arg)
    {
      free (args_info->reportname_arg); /* free previous argument */
      args_info->reportname_arg = 0;
    }
  if (args_info->reportname_orig)
    {
      free (args_info->reportname_orig); /* free previous argument */
      args_info->reportname_orig = 0;
    }
  if (args_info->xmlconf_arg)
    {
      free (args_info->xmlconf_arg); /* free previous argument */
      args_info->xmlconf_arg = 0;
    }
  if (args_info->xmlconf_orig)
    {
      free (args_info->xmlconf_orig); /* free previous argument */
      args_info->xmlconf_orig = 0;
    }
  if (args_info->mediadir_arg)
    {
      free (args_info->mediadir_arg); /* free previous argument */
      args_info->mediadir_arg = 0;
    }
  if (args_info->mediadir_orig)
    {
      free (args_info->mediadir_orig); /* free previous argument */
      args_info->mediadir_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->devconfdir_given) {
    if (args_info->devconfdir_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "devconfdir", args_info->devconfdir_orig);
    } else {
      fprintf(outfile, "%s\n", "devconfdir");
    }
  }
  if (args_info->reportname_given) {
    if (args_info->reportname_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "reportname", args_info->reportname_orig);
    } else {
      fprintf(outfile, "%s\n", "reportname");
    }
  }
  if (args_info->xmlconf_given) {
    if (args_info->xmlconf_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "xmlconf", args_info->xmlconf_orig);
    } else {
      fprintf(outfile, "%s\n", "xmlconf");
    }
  }
  if (args_info->mediadir_given) {
    if (args_info->mediadir_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "mediadir", args_info->mediadir_orig);
    } else {
      fprintf(outfile, "%s\n", "mediadir");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "devconfdir",	1, NULL, 'd' },
        { "reportname",	1, NULL, 'r' },
        { "xmlconf",	1, NULL, 'c' },
        { "mediadir",	1, NULL, 'm' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVd:r:c:m:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          if (local_args_info.version_given)
            {
              fprintf (stderr, "%s: `--version' (`-V') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->version_given && ! override)
            continue;
          local_args_info.version_given = 1;
          args_info->version_given = 1;
          cmdline_parser_free (&local_args_info);
          return 0;

        case 'd':	/* the directory with device configurations.  */
          if (local_args_info.devconfdir_given)
            {
              fprintf (stderr, "%s: `--devconfdir' (`-d') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->devconfdir_given && ! override)
            continue;
          local_args_info.devconfdir_given = 1;
          args_info->devconfdir_given = 1;
          if (args_info->devconfdir_arg)
            free (args_info->devconfdir_arg); /* free previous string */
          args_info->devconfdir_arg = gengetopt_strdup (optarg);
          if (args_info->devconfdir_orig)
            free (args_info->devconfdir_orig); /* free previous string */
          args_info->devconfdir_orig = gengetopt_strdup (optarg);
          break;

        case 'r':	/* the name for exported XML report.  */
          if (local_args_info.reportname_given)
            {
              fprintf (stderr, "%s: `--reportname' (`-r') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->reportname_given && ! override)
            continue;
          local_args_info.reportname_given = 1;
          args_info->reportname_given = 1;
          if (args_info->reportname_arg)
            free (args_info->reportname_arg); /* free previous string */
          args_info->reportname_arg = gengetopt_strdup (optarg);
          if (args_info->reportname_orig)
            free (args_info->reportname_orig); /* free previous string */
          args_info->reportname_orig = gengetopt_strdup (optarg);
          break;

        case 'c':	/* the XML configuration file.  */
          if (local_args_info.xmlconf_given)
            {
              fprintf (stderr, "%s: `--xmlconf' (`-c') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->xmlconf_given && ! override)
            continue;
          local_args_info.xmlconf_given = 1;
          args_info->xmlconf_given = 1;
          if (args_info->xmlconf_arg)
            free (args_info->xmlconf_arg); /* free previous string */
          args_info->xmlconf_arg = gengetopt_strdup (optarg);
          if (args_info->xmlconf_orig)
            free (args_info->xmlconf_orig); /* free previous string */
          args_info->xmlconf_orig = gengetopt_strdup (optarg);
          break;

        case 'm':	/* the name for the directorty for all exported media files (images, RRD files).  */
          if (local_args_info.mediadir_given)
            {
              fprintf (stderr, "%s: `--mediadir' (`-m') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->mediadir_given && ! override)
            continue;
          local_args_info.mediadir_given = 1;
          args_info->mediadir_given = 1;
          if (args_info->mediadir_arg)
            free (args_info->mediadir_arg); /* free previous string */
          args_info->mediadir_arg = gengetopt_strdup (optarg);
          if (args_info->mediadir_orig)
            free (args_info->mediadir_orig); /* free previous string */
          args_info->mediadir_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */

      i = optind;
      while (i < argc)
        if (argv[i++] == argv[0]) {
          found_prog_name = 1;
          break;
        }
      i = 0;

      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        if (argv[optind++] != argv[0])
          args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind-1]) ;
    }

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
