#ifndef RRDWRAP_H
#define RRDWRAP_H

/* necessary declaration for class definition */
#include <string>
#include <vector>

/* forward declaration - for pointers and references */

/**
 * @brief A class which wraps some rrd function calls.
 */
class RRDWrap
{
  private:
   /** @brief the filename for the RRD file */
   std::string mFileName;
  public:
   /** @brief empty constructor, just init the variables */
   RRDWrap():mFileName("") {}
   /** @brief constructor with an initializing the filename */
   RRDWrap(const std::string& name):mFileName(name) {}
   /** @brief smple empty destructor */
   ~RRDWrap() {}

   //setters, getters
   std::string getFileName() { return mFileName; }
   /** @brief create RRD database file */
   void create(const std::vector<std::string>& argArr);
   /** @brief update RRD database file */
   void update(const std::string& opt);
   /** @brief create a graph from the RRD database */
   void graph(const std::vector<std::string>& argArr);
};

#endif
