/**
 * @file
 * @brief E1 controller class tests
 * @author Miroslav Kubelk
 * @date Jul 2007
 */

/* autoheader config */
#include "../src/config.h"

//STDC++ and STL Headers
#include <iostream>

//C and local headers
#include "ciscoconf/E1Controller.h"
#include "ciscoconf/SyncSummary.h"

//global variables

//function prototypes

/** MAIN entry point*/
int main(int argc, char *argv[])
{
 E1Controller e1Contr;

 std::string line("controller E1 1/0");
 e1Contr.parsContrSection(line);
 line="channel-group 1 timeslots 1-10";
 e1Contr.parsContrSection(line);
 line="channel-group 2 timeslots 11,12-15,16";
 e1Contr.parsContrSection(line);
 line="channel-group 3 timeslots 30";
 e1Contr.parsContrSection(line);
 
 SyncSummary SyncSummary(e1Contr);
 SyncSummary.printDebuginfo();

 std::cout << "testing return values ...";

 if (SyncSummary.getAllTimeslots() == 32 &&
     SyncSummary.getFreeTimeslots() == 14 &&
     SyncSummary.getUsedTimeslots() == 18 &&
     SyncSummary.getAllE1() == 1 &&
     SyncSummary.getFreeE1() == 0 &&
     SyncSummary.getUsedE1() == 1 &&
     SyncSummary.getChannelGroups() == 3
    ) std::cout << " OK" << std::endl;
 else {
  std::cout << " FALSE" << std::endl;
  exit(EXIT_FAILURE);
 }
     

 exit(EXIT_SUCCESS);
}
