/**
 * @file
 * @brief utils class tests
 * @author Miroslav Kubelk
 * @date Jul 2007
 */

/* autoheader config */
#include "../src/config.h"

//STDC++ and STL Headers
#include <iostream>
#include <string>
#include <iterator>

//C and local headers
#include <unistd.h>
#include "utils/Utils.h"

#ifndef HAVE_SCANDIR
 #include "utils/scandir.h"
#endif

//global variables

//function prototypes
void waitingBaby(unsigned int us);
void testTokenize();

/** MAIN entry point*/
int main(int argc, char *argv[])
{
 std::string dirName="../../";
 std::vector<std::string> files( Utils::getDirFiles(dirName) );
 std::cout << "files in directory " << dirName << ":" << std::endl;
 for (std::vector<std::string>::iterator iter=files.begin();iter<files.end();iter++) {
  std::cout << *iter << std::endl;
 }

 //tokenize test
 testTokenize();
 
 exit(EXIT_SUCCESS);
}

//---------------------------------------------------------------------------
void testTokenize()
{
 std::cout << "Tokenizer test" << std::endl;
 
 std::vector<std::string> tokens;
 std::string str("Split me up! Word1 Word2 Word3.");
 std::cout << "original string: " << str << std::endl;

 Utils::Tokenize(str,tokens);
 
 std::cout << "tokens: ";
 copy(tokens.begin(), tokens.end(), std::ostream_iterator<std::string>(std::cout, ", "));
}

//---------------------------------------------------------------------------
void waitingBaby(unsigned int us)
{
/*
struct timespec tv;
tv.tv_sec=0;
tv.tv_nsec=(long int)10e6;
nanosleep(&tv,NULL);
*/
//usleep(us);
}
