<?php
/**
 * Base url getter that return the base url for a whole application
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */

/**
 * Class that returns the base url for the current request.
 *
 * @package ndevinfo*
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */
class AppBaseUrl
{
 /**
  * simple cache for the base url
  * @var string
  */
 private static $_baseUrl=null;

//==============================================================================
/**
 * Get the base url for the current request.
 * @return string
 */
public static function getBaseUrl()
{
 if (self::$_baseUrl == null)
  self::$_baseUrl = Zend_Controller_Front::getInstance()->getRequest()->getBaseUrl();

 return self::$_baseUrl;
}

#END CLASS
}
