<?php
/**
 * Implementation of Index Controller actions
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */

/**
 * Serve main Index controller actions.
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */
class IndexController extends Zend_Controller_Action
{
//==============================================================================
/**
 * Action handler for index page
 */
public function indexAction()
{
 //left block
 $this->view->leftBlocks = SiteTemplatePlugin::getDefaultLeftParts();

 $devObj=new CiscoDevice();
 $groupObj=new DeviceGroup();

 $this->view->devCount=$devObj->getAllDevicesCount();
 $this->view->groupCount=$groupObj->getAllGroupsCount();
}

//==============================================================================
/**
 * Action handler for about page
 */
public function aboutAction()
{
 //set active about main menu item
 SiteTemplatePlugin::setMainMenu(SiteTemplatePlugin::MAINMENU_ABOUT);
 //left block
 $this->view->leftBlocks = SiteTemplatePlugin::getDefaultLeftParts();
}

#END CLASS
}
