<?php
/**
* Implementation of the summary base class.
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/

/**
* class for the summary base - business (domain) class
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/
class BaseSum extends Model
{
 /**
  * a number of all items
  * @var int
  */
 private $_summary;

 /**
  * a number of used items
  * @var int
  */
 private $_used;
 
 /**
  * a number of free items
  * @var int
  */
 private $_free;
 
 /**
  * the utilization, a ratio of used and all items
  * @var int
  */
 private $_utilization;

//==============================================================================
public function __get($property)
{
 switch ($property) {
  case "Summary":
   return $this->_summary;
   break;
  case "Used":
   return $this->_used;
   break;
  case "Free":
   return $this->_free;
   break;
  case "Utilization":
   return $this->_utilization;
   break;
  default:
   return parent::__get($property);
 	 break;
 }
}

//==============================================================================
public function setDaoByBaseSummaryXml(SimpleXMLelement $baseSumXML)
{
 $this->_dao=new BaseSumXMLDao($baseSumXML);
}

//==============================================================================
/**
 * Sets properties from the transfer object
 * @param BaseSumTO $baseSumTO transfer object
 */
private function _setFromTO(BaseSumTO $baseSumTO)
{
 $this->_summary=$baseSumTO->summary;
 $this->_used=$baseSumTO->used;
 $this->_free=$baseSumTO->free;
 $this->_utilization=$baseSumTO->utilization;
}

//==============================================================================
/**
 * Init properties from dao.
 */
public function setData()
{
 $this->_setFromTO( $this->_dao->getBaseSum() );
}

#END CLASS
}

