<?php
/**
* Implementation of the E3 device controller class
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/

/**
* class for the E3 device controller
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/
class E3Contr extends DeviceContr
{
 /**
  * the number of sub E1 controllers
  */
 const SUBE1_COUNT=16;

//==============================================================================
public function setDaoByControllersXML(SimpleXMLelement $controllersXML)
{
 $this->_dao=new E3ContrXMLDao($controllersXML);
}

//==============================================================================
/**
 * Get all sub E1 controllers for the current E3 controller.
 * @return array array of the E1Contr objects
 */
public function &getSubE1Controllers()
{
 $e1Contr=new E1Contr();
 $e1Contr->setDaoByControllersXML( E3ContrXMLDao::getSubE1ControllersXML($this->_dao->getControllerXML($this->_name)) );
 $retArr=&$e1Contr->getAllControllers();

 if(count($retArr)!=self::SUBE1_COUNT)
  throw new Exception("The number of sub e1 controllers for the E3 controller is not ".self::SUBE1_COUNT.", maybe bad XML source. "
   . "E3 controller: $this->_name");

 return $retArr;
}

#END CLASS
}
