<?php
/**
* The implementation of the URL Enumerator for index controller URLs
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/

/**
* URL enumerator for index controller URLs
*
* @package ndevinfo
* @author Miroslav Kubelik (koubel@volny.cz)
* @copyright Copyright (c) 2007 Miroslav Kubelik
* @license http://opensource.org/licenses/gpl-license.php GNU GPL
*/
class IndexUrlEnum extends UrlEasyGet
{
//==============================================================================
/**
 * Create object, set members
 */
public function __construct()
{
 $config=Zend_Registry::get("conf");
 //constructor with XML file from controller directory
 parent::__construct($config->controllerDir
  . DIRECTORY_SEPARATOR . "IndexControllerMap.xml");
}

//==============================================================================
/**
 * Factory method, usefull for calling in views, like the helper
 * @return object IndexUrlEnum
 */
public static function factory()
{
 return new self;
}

//==============================================================================
/**
 * Main function, return URL which is defined by urlName in the XML file.
 * @param string $urlName
 * @return string
 */
public function __get($urlName)
{
 //get URL defined by the map
 $url=parent::__get($urlName);

 //add baseUrl and return
 return (AppBaseUrl::getBaseUrl().$url);
}

#END CLASS
}
