<?php
/**
 * Implementation of the simple search left block.
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */

/**
 * Class, that represents simple search left block.
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */
class LeftBlock_SimpleSearch extends LeftBlock
{
/**
 * Initializes necessary member varibles.
 * @param string $actionUrl an url for the search result action
 * Sets:
 * - the template for the block
 * - the view for the block
 */
//==============================================================================
public function __construct($actionUrl)
{
 $this->setContentTemplate("simpleSearch.phtml");
 $view=ViewFactory::getDefaultAppView();
 $view->actionUrl=$actionUrl;
 $this->setContentView($view);
}

//==============================================================================
/** Gets object for the right side simple device search block
 * @return LeftBlock_SimpleSearch
 */
public static function getDeviceSearch()
{
 $searchBlock = new self(DeviceUrlEnum::factory()->searchResult);
 $searchBlock->title = "Device search";
 return $searchBlock;
}

//==============================================================================
/** Gets object for the right side simple group search block
 * @return LeftBlock_SimpleSearch
 */
public static function getDevGroupSearch()
{
 $searchBlock = new self(DevgroupUrlEnum::factory()->searchResult);
 $searchBlock->title = "Group search";
 return $searchBlock;
}

#END CLASS
}
