<?php
/**
 * The implementation for a application view factory.
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */

/**
 * Application view factory for application specific view.
 *
 * @package ndevinfo
 * @author Miroslav Kubelik (koubel@volny.cz)
 * @copyright Copyright (c) 2007 Miroslav Kubelik
 * @license http://opensource.org/licenses/gpl-license.php GNU GPL
 */
class ViewFactory
{
//==============================================================================
/**
 * Returns application specific view.
 * View directory and helper directory are set from the application configuration
 * object.
 * @return Zend_View_Interace
 */
public static function getDefaultAppView()
{
 $config = Zend_Registry::get("conf");

 $view=new Zend_View();

 $view->setScriptPath($config->viewDir . DIRECTORY_SEPARATOR . "scripts");
 $view->addHelperPath($config->viewHelperDir);
 
 return $view;
}

#END CLASS
}
